﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace 打磚塊遊戲
{
    public partial class Form1 : Form
    {
        PictureBox 球拍 = new PictureBox();
        PictureBox 球 = new PictureBox();
        PictureBox[,] 磚塊陣列 = new PictureBox[8, 12];
        Random 亂數 = new Random();//亂數種子
        int 水平移動量, 垂直移動量;
        
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            水平移動量 = 0 - 亂數.Next(5, 10); 垂直移動量 = 0 - 亂數.Next(5, 10);

            int 畫面寬度 = this.Bounds.Width;
            int 畫面高度 = this.Bounds.Height;
            int 間隔 = 5;

            球拍.Width = 200; 球拍.Height = 30; 球拍.Load("bar.png"); 球拍.SizeMode = PictureBoxSizeMode.StretchImage;
            球拍.Left = (畫面寬度 - 球拍.Width) / 2;
            球拍.Top = ( 畫面高度 - 球拍.Height - 10);
            this.Controls.Add(球拍); //將球拍物件加入表單控制項集合

            球.Load("ball.png"); 球.SizeMode = PictureBoxSizeMode.AutoSize;
            球.Left = (畫面寬度 - 球.Width) / 2;
            球.Top = 球拍.Top - 球.Height;
            this.Controls.Add(球); //將球拍物件加入表單控制項集合


            //建立6x12個磚塊，並將這些磚塊放入磚塊陣列
            int 磚塊寬度 = (畫面寬度 - 間隔) / 12 - 間隔;
            int 磚塊高度 = 30;
            String[] 磚塊陣列色彩集合 = new String[] {  "brick-blue.png", 
                                                        "brick-blue.png", 
                                                        "brick-green.png", 
                                                        "brick-green.png",
                                                        "brick-orange.png",
                                                        "brick-orange.png",
                                                        "brick-red.png",
                                                        "brick-red.png"};
            for (int i = 0; i <= 7; i++)
            {
                for (int j = 0; j <= 11; j++)
                {
                    PictureBox 磚塊 = new PictureBox();
                    磚塊.Width = 磚塊寬度; 磚塊.Height = 磚塊高度;
                    磚塊.Left = 間隔 + (磚塊寬度 + 間隔) * j;
                    磚塊.Top = 間隔 + (磚塊高度 + 間隔) * i;

                    磚塊.Load(磚塊陣列色彩集合[i]); 磚塊.SizeMode = PictureBoxSizeMode.StretchImage;
              
                    this.Controls.Add(磚塊);
                    磚塊陣列[i, j] = 磚塊;
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {


            //球的邊界碰撞
            if (球.Left < 0 || 球.Left > this.Bounds.Width) 水平移動量 = -水平移動量; //左右邊界
            if (球.Top > this.Bounds.Height || 球.Top < 0) 垂直移動量 = -垂直移動量; //上下邊界

            //球拍的移動
            if (Cursor.Position.X >= (this.Bounds.Width - 球拍.Width))//如果游標在右邊界處 
                球拍.Left = this.Bounds.Width - 球拍.Width;//減去 球拍的水平位置，否則的話，球拍會在視窗 
            else 球拍.Left = Cursor.Position.X; //球拍的水平位置 = 游標的水平位置

            //一一測試每顆磚塊是否被球擊中
            for (int i = 0; i < 磚塊陣列.GetLength(0); i++)
            {
                for (int j = 0; j < 磚塊陣列.GetLength(1); j++)
                {
                    if (磚塊陣列[i, j].Visible == true) // 若磚塊是可見的話…，表示磚塊尚未被擊中
                    {
                        if (球.Left >= 磚塊陣列[i, j].Left && 球.Left <= (磚塊陣列[i, j].Left + 磚塊陣列[i, j].Width) && 球.Top <= (磚塊陣列[i, j].Top + 磚塊陣列[i, j].Height))
                        {
                            水平移動量 = -水平移動量;
                            磚塊陣列[i, j].Visible = false; //判定擊中後，球的垂直移動方向改變，並將磚塊的Visible屬性設false，使其看不見
                            goto HitBrickExit; //一旦擊中，就不用測試其他的磚塊…，跳離這個測試以節省時間
                        }
                    }
                }
            }

        HitBrickExit:

            //球拍是否擊中球：
            if (球.Left > 球拍.Left && 球.Left <= (球拍.Left + 球拍.Width) && 球.Top > (球拍.Top - 球.Height))
            {
                水平移動量 = -水平移動量;
                垂直移動量 = -垂直移動量;
            }

            球.Top += 垂直移動量;
            球.Left += 水平移動量;
        }
    }
}
